#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include "ido.h"
#include "hivas.h"
#include "hivaslista.h"



HivasElem* listaelejere(HivasElem* hivaslista, HivasElem* h)
	{
	h->kov = hivaslista;
	hivaslista = h;
	return hivaslista;
	}

void listahoz(HivasElem* hivaslista, HivasElem* h)
	{
	HivasElem* vege;
	for(vege = hivaslista; vege->kov != NULL; vege = vege->kov);
	vege->kov = h;
	}

void torolhivas(HivasElem* h)
	{
	free(h);
	//h = NULL;
	}

HivasLista* ujnaplista(HivasElem* munkakezdig, HivasElem* munkavegtol)
	{
	HivasLista* ujlista;
	ujlista = (HivasLista*) malloc(sizeof(HivasLista));
	ujlista->munkaelott = munkakezdig;
	ujlista->munkautan = munkavegtol;
	ujlista->munkaelott->kov = ujlista->munkautan;
	ujlista->munkautan->kov = NULL;
	return ujlista;
	}


void torol_napilista(HivasLista* hivaslista)
	{
	HivasElem* ezt = hivaslista->munkaelott->kov; //tudom, hogy a munkaelott torlesevel is kezdhetnem, de igy jobban tetszik
	while(ezt != NULL) {
			hivaslista->munkaelott->kov = ezt->kov;
			if(ezt != hivaslista->munkautan)
				torolhivas(ezt);
			else
				hivaslista->munkautan->kov = NULL;
			ezt = hivaslista->munkaelott->kov;
			}
	torolhivas(hivaslista->munkaelott);
	torolhivas(hivaslista->munkautan);
	free(hivaslista);
	//hivaslista = NULL;

	}

void listainput(HivasLista * hivaslista, FILE * input)
	{
	HivasElem* ide = hivaslista->munkaelott;
	int ko, kp, km, vo, vp, vm;
	int ssz = 0;
	while (fscanf(input, "%d %d %d %d %d %d^\n", &ko, &kp, &km, &vo, &vp, &vm) == 6) {
			ssz++;
			HivasElem* uj;
			uj = (HivasElem*)malloc(sizeof(HivasElem));
			hivasinic(&uj->hiv, ssz, idoinic(ko, kp, km), idoinic(vo, vp, vm));
			if(ide->kov == NULL) { //lista végére mutat, munkaido vege utáni hivas, beszur a végére, ahol épp a mutato van.
					uj->kov = ide->kov; //NULL átadása
					ide->kov = uj; //befuz
					ide = uj; //továbblép
					}
			else {
					if(uj->hiv.kezd.ido > hivaslista->munkautan->hiv.kezd.ido) { //elso munkaido utáni hivás, átlépi a "strázsát"
							ide = hivaslista->munkautan; //ide továbblép
							uj->kov = ide->kov; //NULL átadása
							ide->kov = uj; // befuz
							ide = uj; //továbblép
							}
					else {   //munkaidő vége előtti hívás, az eddigiek után, a "strázsa" elé beszur
							uj->kov = hivaslista->munkautan; //strázsa átadása
							ide->kov = uj; //befuz
							ide = uj; //továbblép
							}
					}
			}
	}


/*3-7. feladat*/
void orankent(HivasLista * hivaslista)
	{
	int ora[24] = {0};
	HivasElem* ez;
	for(ez = hivaslista->munkaelott->kov; ez != NULL; ez = ez->kov)
		if(ez != hivaslista->munkautan)
			ora[ez->hiv.kezd.ora]++;
	int i;
	for(i = 0; i < 24; i++)
		if(ora[i] != 0)
			printf("\t%2d ora %3d hivas\n", i, ora[i]);
	}

void maxhivashossz(HivasLista * hivaslista)
	{
	HivasElem * max = hivaslista->munkaelott->kov;
	HivasElem * ez;
	int hossz = hivashossz(max->hiv);
	for (ez = max->kov; ez != NULL; ez = ez->kov)
		if(ez != hivaslista->munkautan && hivashossz(ez->hiv) > hossz)
			max = ez, hossz = hivashossz(max->hiv);
	printf("\tA leghosszabb ideig vonalban levo hivo %d. sorban szerepel, \n\ta hivas hossza: %d masodperc.\n", max->hiv.sorszam, hossz);
	}

void beszelo(HivasLista * hivaslista)
	{
	HivasElem* munkaido;
	munkaido = (HivasElem*)malloc(sizeof(HivasElem));
	hivasinic(&munkaido->hiv, 0, hivaslista->munkaelott->hiv.veg, hivaslista->munkautan->hiv.kezd);
	int ora, perc, mp;
	printf("\tAdjon meg egy idopontot! (ora perc masodperc): ");
	scanf("%d %d %d", &ora, &perc, &mp);
	Ido ekkor = idoinic(ora, perc, mp);
	HivasElem* ez;
	int db = -1;
	if(hiv_e(munkaido->hiv, ekkor)) {
			for(ez = hivaslista->munkaelott->kov; ez != hivaslista->munkautan && !hiv_e(ez->hiv, ekkor); ez = ez->kov);
			if (ez != hivaslista->munkautan) {
					HivasElem* az;
					db = 0;
					for(az = ez->kov; az != hivaslista->munkautan && az->hiv.kezd.ido < ekkor.ido; az = az->kov)
						if(hiv_e(az->hiv, ekkor)) db++;

					}
			}
	if (db > -1)
		printf("\tA varakozok szama: %d a beszelo a %d. hivo.\n", db, ez->hiv.sorszam);
	else
		printf("\tNem volt beszelo.\n");

	torolhivas(munkaido);
	}
